<template>
    <div class="add-edit">
        <h1>{{msg}}</h1>
        <div class="inputs">
            <input
                type="text"
                @focus="nameError=false"
                class="name-input"
                :class="{'error-input': nameError}"
                @keyup.enter="validateFields"
                v-model="localContact.name"
                placeholder="Name"
            />
            <p class="error-text" v-if="nameError">A person needs a name</p>
            <input
                type="text"
                @focus="surnameError=false"
                class="surname-input"
                :class="{'error-input': surnameError}"
                @keyup.enter="validateFields"
                v-model="localContact.surname"
                placeholder="Surname"
            />
            <p class="error-text" v-if="surnameError">A person needs a surname</p>
            <input
                type="text"
                @focus="telephoneError=false"
                class="telephone-input"
                :class="{'error-input': telephoneError}"
                @keyup.enter="validateFields"
                v-model="localContact.telephone"
                placeholder="Telephone"
            />
            <p class="error-text" v-if="telephoneError">A person needs a phone number</p>
            <p
                class="error-text"
                v-if="telephoneInvalidError"
            >A valid telephone needs at least 5 characters</p>
            <input
                type="text"
                @focus="emailError=false; emailInvalidError=false"
                class="email-input"
                :class="{'error-input': emailError || emailInvalidError}"
                @keyup.enter="validateFields"
                v-model="localContact.email"
                placeholder="Email"
            />
            <p class="error-text" v-if="emailError">A person needs an email</p>
            <p class="error-text" v-if="emailInvalidError">A valid email</p>
            <p class="error-text" v-if="error">All fields are compulsory</p>
        </div>
        <div class="buttons">
            <button id="back-button" @click="goBack">Back</button>
            <button id="ok-button" @click="validateFields">OK</button>
        </div>
    </div>
</template>

<script>
export default {
    name: 'AddEdit',
    props: {
        msg: { propType: String },
        selectedContact: { propType: Object, required: true },
    },
    data() {
        return {
            localContact: {
                name: null,
                surname: null,
                telephone: null,
                email: null,
            },
            nameError: false,
            surnameError: false,
            telephoneError: false,
            telephoneInvalidError: false,
            emailError: false,
            emailInvalidError: false,
            error: false,
        }
    },
    watch: {
        selectedContact: {
            immediate: true,
            handler: function(newValue) {
                this.localContact = JSON.parse(JSON.stringify(newValue))
            },
        },
    },
    methods: {
        acceptEdit() {
            this.$emit('emit-ok', this.localContact)
        },

        goBack() {
            this.$emit('emit-back')
        },
        validateEmail(email) {
            var re = new RegExp(
                /^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$/
            )
            const result = re.test(String(email).toLowerCase())
            return result
        },
        validateFields() {
            if (this.localContact.name === null) {
                this.error = true
                this.nameError = true
            }
            if (this.localContact.surname === null) {
                this.error = true
                this.surnameError = true
            }
            if (this.localContact.telephone === null) {
                this.error = true
                this.telephoneError = true
            } else {
                if (this.localContact.telephone.length < 5) {
                    this.error = true
                    this.telephoneInvalidError = true
                }
            }
            if (this.localContact.email === null) {
                this.error = true
                this.emailError = true
            }
            if (!this.validateEmail(this.localContact.email)) {
                this.error = true
                this.emailInvalidError = true
            }
            if (!this.error) {
                this.acceptEdit()
            }
            this.error = false
        },
    },
}
</script>

<style scoped>
h1 {
    margin-top: 0.4rem;
    margin-bottom: 0.8rem;
}
.add-edit {
    padding: 2.3rem 3.3rem;
    border-radius: 2rem;
    background: white;
    -webkit-box-shadow: 0.5rem 1rem 0.9rem 0.2rem #ccccccb8;
    -moz-box-shadow: 0.5rem 1rem 0.9rem 0.2rem #ccccccb8;
    box-shadow: 0.5rem 1rem 0.9rem 0.2rem #ccccccb8;
    margin-bottom: 2rem;
    width: 19rem;
}

.inputs {
    display: flex;
    flex-direction: column;
}

input {
    font-family: 'Roboto';
    border: none;
    background: #cdcdcd29;
    color: #484848;
    padding: 0.7rem;
    letter-spacing: 1px;
    margin-top: 1.7rem;
    font-size: 1rem;
}

.error-input {
    border: 2px solid #f17b7b;
}

.error-text {
    color: #f17b7b;
    font-size: small;
    text-align: right;
}

.buttons {
    margin-top: 3rem;
    display: flex;
    justify-content: space-between;
}

button {
    color: white;
    font-size: 1rem;
    border: none;
    border-radius: 200%;
    cursor: pointer;
    background: rgba(103, 156, 137, 0.6);
    padding: 0.5rem 1.2rem;
}

#back-button {
    background: rgba(111, 126, 161, 0.6);
    padding: 0.1rem 1.1rem;
}
#back-button:hover {
    background: rgba(111, 126, 161, 0.9);
}

#ok-button {
    background: rgba(103, 156, 137, 0.6);
    padding: 1.4rem 1.4rem;
}
#ok-button:hover {
    background: rgba(103, 156, 137, 0.9);
}

@media only screen and (max-width: 600px) {
    .add-edit {
        -webkit-box-shadow: 0.5rem 1rem 0.9rem 0.2rem #ffffff;
        -moz-box-shadow: 0.5rem 1rem 0.9rem 0.2rem #ffffff;
        box-shadow: 0.5rem 1rem 0.9rem 0.2rem #ffffff;
    }
}
</style>
